#include "NativeApp.h"
#include <rag/Event.h>
#include <rag/Timer.h>
#include "external/NDKHelper/NDKHelper.h"
#include <rag/InputManager.h>
#include <rag/ResourceMgr.h>
#include <rag/Renderer.h>

using namespace rag;
using namespace events;
using namespace std;

NativeApp::NativeApp()
{
}

NativeApp::~NativeApp()
{
}

void NativeApp::onLogicUpdate()
{
	static Chrono chrono;
	static float currentTime = 0;

	// Updates the static multi-purpose timers
	float newTime = chrono.getElapsedTime();
	float delta = (newTime - currentTime) * Timer::timeFactor; // For cheating and debugging, allow time control.
	Timer::deltaTime = std::min(0.05f, delta); // clamp to a maximum.
	Timer::totalTime += Timer::deltaTime;       // total time increases with the clamped value.
	currentTime = newTime;

    
    // Handle NDK events.
    ndkhelper.handleMessageQueue();
    
    // Process input event queue.
	InputManager::getInstance().traverse(&stage);
    
    stage.logicTraversal();
    
    resourcemgr.update();
    
    DisplayObject::deletePendentObjects();
}

void NativeApp::onRender()
{
	static glm::mat3 identity(1.0);
    static Color color;
    
	Timer timer;
	timer.start(1);
	stage.renderTraversal(color);
	Renderer::getInstance().getRenderTarget().flush();
}

