#include "androidUtils.h"

static android_app* app = NULL;

#define EXCEPTION_RETURN(env) \
if (env->ExceptionOccurred()) { \
env->ExceptionDescribe(); \
env->ExceptionClear(); \
return 0; \
}

android_app* AndroidUtils::getApp()
{
	return app;
}

void AndroidUtils::setApp(android_app* _app)
{
	app = _app;
}

std::string AndroidUtils::getLanguage()
{
	JNIEnv* jni;
	AndroidUtils::getApp()->activity->vm->AttachCurrentThread(&jni, NULL);
    
	jclass thisClass = jni->GetObjectClass(AndroidUtils::getApp()->activity->clazz);
	EXCEPTION_RETURN(jni);
    
	jmethodID method = jni->GetStaticMethodID(thisClass,
                                                      "getLanguage", "()Ljava/lang/String;");
	EXCEPTION_RETURN(jni);
    
	jstring returnString = (jstring)jni->CallStaticIntMethod(thisClass, method);
	EXCEPTION_RETURN(jni);

	const char *js = jni->GetStringUTFChars(returnString, NULL);
    std::string cs(js);
    jni->ReleaseStringUTFChars(returnString, js);
    return cs;
}