//
//  NDKHelper.h
//  EasyNDK-for-cocos2dx
//
//  Created by Amir Ali Jiwani on 23/02/2013.
//
//

#ifndef __EasyNDK_for_cocos2dx__NDKHelper__
#define __EasyNDK_for_cocos2dx__NDKHelper__

#include <string>
#include <vector>
#include <queue>
#include "jansson.h"
#include <rag/EventDispatcher.h>

#define ndkhelper NDKHelper::getInstance()

namespace events
{   
    class NDKMessage: public Event
    {
    public:
        
        NDKMessage(std::string type): Event(type) {}
        
        json_t* json;
    };
}

class NDKHelper: public events::EventDispatcher
{
public :
    
    static NDKHelper& getInstance();
    
    // Call a Java method, with the given parameters. Method must be public.
    void sendMessage(std::string methodName, json_t* methodParams = NULL);
    
    // Call synchronously a Java method. Method must be public and static.
    // You're responsible to decref json_t* return value.
    // Java method signature is:
    //      public static String methodId(String)
    json_t* sendMessageSync(std::string methodName, json_t* methodParams = NULL);

    // Called by the engine
    void enqueueMessage(const std::string& json);
    void handleMessageQueue();
    
private:
    
    NDKHelper();

    void handleMessage(json_t *methodName, json_t* methodParams);

    std::queue<std::string> messages;
};

#endif /* defined(__EasyNDK_for_cocos2dx__NDKHelper__) */
