#include "EventDispatcher.h"
#include <algorithm>

using namespace std;
using namespace events;


EventDispatcher::EventDispatcher()
{
}

void EventDispatcher::addEventListener(std::string type, EventListener* listener)
{
    listeners[type].push_back(listener);
}

void EventDispatcher::dispatchEvent(Event &event)
{
    if (!hasEventListener(event.type)) return;
    
    vector<EventListener*> elisteners = listeners[event.type];
    
    int size = elisteners.size();
    
    for (int i = 0; i < size; ++i)
        elisteners[i]->onEvent(event.type, event);
}

bool EventDispatcher::hasEventListener(std::string type)
{
    return listeners.find(type) != listeners.end();
}


void EventDispatcher::removeEventListener(string type, EventListener* listener)
{
    if (!hasEventListener(type)) return;
    
    vector<EventListener*>& elisteners = listeners[type];
    
    
    vector<EventListener*>::iterator it = find(elisteners.begin(), elisteners.end(), listener);
    
    if (it != elisteners.end())
    {
        elisteners.erase(it);
    }
    
    if (elisteners.size() == 0)
    {
        listeners.erase(type);
    }
}

