#ifndef Rag_EventDispatcher_h
#define Rag_EventDispatcher_h

#include <string>
#include "EventListener.h"
#include "Event.h"
#include <map>
#include <vector>

namespace events
{
	/// Base class used to dispatch events.
	/** \sa Event, EventListener */
    class EventDispatcher
    {
    public:
        
        EventDispatcher();
		virtual ~EventDispatcher(){};
        
        void addEventListener(std::string type, EventListener* listener);
        void dispatchEvent(Event& event);
        bool hasEventListener(std::string type);
        void removeEventListener(std::string type, EventListener* listener);
        
    private:
        
        std::map<std::string, std::vector<EventListener*> > listeners;
        
    };
}


#endif
