#ifndef rmm_ITextFont_h
#define rmm_ITextFont_h

#include <string>
#include <glm/glm.hpp>

namespace rag
{
    /// Interface for text fonts.
    class ITextFont
    {
    public:
        
        virtual ~ITextFont(){};
        
        virtual int     getWidth(const std::string& text) = 0;							///< Returns the width of a text
        virtual void    print(const std::string& text, const glm::mat4& matrix) = 0;    ///< Renders text. Asumes ortho projection 1:1 screen pixel.
        
        virtual void    setLetterSpacing(float value) {};								///< Sets the extra space between characters.
        virtual void    reloadTexture() {};												///< On context loss, reload textures. \TODO ITextFont should inherit Resource. Reload should be part of resource.
        
    };
}

#endif
