#ifndef _IMAGE_LOADER_JPG_H_
#define _IMAGE_LOADER_JPG_H_

#include <rag/Platform.h>
#include <rag/File.h>
#include <rag/Image.h>
#include <libjpeg/jpeglib.h>
#include <libjpeg/jerror.h>
#include "ImageLoader.h"

namespace rag
{
	/// Loader for .jpg format.
	class ImageLoaderJPG: public ImageLoader
	{
	public:
		ImageLoaderJPG(const std::string& name, rag::Image* image);
		~ImageLoaderJPG();

		virtual bool loadInfo() override;  ///< Load header to know image size
		virtual bool loadImage() override; ///< Load image from a file

	private:

		size_t byte;
		unsigned char* buffer;

		std::string name;
		rag::Image* image;
		int filesize;

		struct jpeg_decompress_struct info;
		struct jpeg_error_mgr err;
	};
}

#endif
