#ifndef _IMAGE_LOADER_PNG_H_
#define _IMAGE_LOADER_PNG_H_

#include <rag/Platform.h>
#include <iostream>
#include <rag/Image.h>
#include <rag/File.h>
#include "libpng/png.h"
#include "ImageLoader.h"

namespace rag
{
	/// Loader for .png format.
	class ImageLoaderPNG: public ImageLoader
	{
	public:

		ImageLoaderPNG(const std::string& name, rag::Image* image);
		~ImageLoaderPNG();
    
		bool loadInfo();  ///< Load header to know image size
		bool loadImage(); ///< Load image from a file

		size_t byte;
		unsigned char* buffer;

	private:

		std::string name;
		rag::Image* image;
		png_structp png_ptr;
		png_infop info_ptr;

		int filesize;
	};
}

#endif