#ifndef Rag_KeyboardEvent_h
#define Rag_KeyboardEvent_h

#include <rag/Event.h>
#include <sstream>

namespace events
{
    static const std::string KEY_DOWN = "KeyDown";
    static const std::string KEY_UP = "KeyUp";
    
	/// Event to handle KeyBoard actions.
    class KeyboardEvent: public Event
    {   
    public:
        
        KeyboardEvent(std::string type): Event(type) {};
        
        std::string key;	///< Key pressed, encoded in UTF-8.
        int charCode;		///< Character code.
        
		/// String representation of the event.
        virtual std::string toString()
        {
            std::ostringstream oss;
            oss << "(key = " << key << ", charCode=" << charCode << ")";
            return oss.str();
        }
    };
}

#endif
