#ifndef Rag_KeyboardManager_h
#define Rag_KeyboardManager_h

#include <rag/EventDispatcher.h>

namespace events
{
    static const std::string KEYBOARD_WILL_HIDE = "KeyboardWillHide";
}

namespace rag
{
	/// Singleton class that dispatches Keyboard events.
	/** \todo It's confusing to have a Keyboard and a KeyboardManager. */
    class KeyboardManager: public events::EventDispatcher
    {
        
    public:
        
		static const int RETURN_KEYBOARD_CODE;
        static KeyboardManager& getInstance()
        {
            static KeyboardManager instance;
            return instance;
        }
        
		/// When called, will generate a standard multi-platform KeyboardEvent.
        void nativeInsertText(std::string text);

		/// When called, will generate a standard multi-platform KeyboardEvent.
        void nativeDeleteBackward();
        
    private:
        
        KeyboardManager();
        
    };
}

#endif
