#include "RenderTarget.h"
#include "Renderer.h"

namespace rag
{

RenderTarget::RenderTarget():
currentMaterial("", "")
{
}

int numDraws = 0;
int numActualDrawCalls = 0;
void RenderTarget::draw(const VertexArray& vertexArray, const Material& material)
{
	numDraws++;

	if (currentMaterial != material)
	{
		flush();
		currentMaterial = material;
	}

	batch.insert(batch.end(), vertexArray.begin(), vertexArray.end());
}

void RenderTarget::flush()
{
	if (batch.empty())
		return;

	renderer.bindTexture(currentMaterial.textureId);
	renderer.bindMaterial(&currentMaterial);

	int stride = sizeof(rag::Vertex);
	renderer.bindVertexArray(&batch[0].position, 2, stride);
	renderer.bindTextureArray(&batch[0].texCoords, 2, stride);
	renderer.bindColorArray(&batch[0].color, 4, stride);

	glDrawArrays(GL_TRIANGLES, 0, batch.size());

	batch.clear();

	numActualDrawCalls++;
}

} // rag