#ifndef Rag_Screen_h
#define Rag_Screen_h

#include <glm/glm.hpp>

namespace rag
{

/// Contains information about the current device
class Screen
{
public:

	static int              width;			///< Virtual width of the screen. Shared across all devices.
	static int              height;			///< Virtual height of the screen. Shared across all devices.
	static glm::vec2        center;			///< Virtual center of the screen. Shared across all devices.

	static int              realWidth;		///< Actual number of pixels of width in the screen.
	static int              realHeight;		///< Actual number of pixels of height in the screen.

	static float            scale;			///< Apple scale
	static float            scaleBest;		///< Maximum scale where no deformation occurs.
	static float            factorX;		///< Factor used to maintain screen width coordinates independent from resolution or aspect ratio.
	static float            factorY;		///< Factor used to maintain screen height coordinates independent from resolution or aspect ratio.

	static bool				isTablet;		///< True if the device is considered a table instead of a phone.
	static bool				isLowPerformer;	///< True for low end devices.
	static bool				isLowRes;		///< True for devices with low resolution screens.
};

} // rag

#endif
