#ifndef RAG_SPINE_H_
#define RAG_SPINE_H_

#include <spine/spine.h>
#include <rag/DisplayObject.h>
#include <rag/Renderer.h>

namespace rag
{
	class Image;
}

namespace spine 
{
	/// Display 2D Skeletal Animations made with the 3rd party tool Spine.
	class SkeletonDrawable : public rag::DisplayObject 
	{
	public:

		SkeletonDrawable(spSkeletonData* skeleton, spAnimationStateData* stateData = 0);
		~SkeletonDrawable();

		virtual void logicUpdate() override;
		virtual void render() override;
		virtual void updateBounds(rag::DisplayObject* targetCoordinateSpace) override;

		rag::VertexArray vertexArray;
		spSkeleton* skeleton;
		spAnimationState* state;
		spSkeletonBounds* skeletonBounds;
		float timeScale;

	private:

		struct RenderState
		{
			rag::Image* image;
			rag::Material::EBlendMode blendMode;
		};

		void draw(rag::VertexArray& vertexArray, RenderState renderState);

		bool ownsAnimationStateData;
		float* worldVertices;
		RenderState states;
	};

} /* namespace spine */
#endif /* RAG_SPINE_H_ */