#ifndef _TextEdit_H_
#define _TextEdit_H_

#include <rag/DisplayObject.h>

namespace events
{
	static const std::string TEXTEDIT_FINISHED = "TextEditFinished";
}

namespace rag
{
	/// Creates a native window to edit a text.
	class TextEdit : public rag::DisplayObject
	{
	public:
		TextEdit(rag::DisplayObject* parent, const std::string& text);

		void close(bool cancel = false);

		const std::string& getValue() { return textValue; }

		static TextEdit* getInstance();

	private:

		void* handle;
		std::string textValue;

		static TextEdit* instance;
	};
}

#endif
