#ifndef Rag_TouchEvent_h
#define Rag_TouchEvent_h

#include <rag/Event.h>
#include <string>
#include <sstream>

namespace events 
{
    
    static const std::string TOUCH_BEGIN = "TouchBegin";
    static const std::string TOUCH_END = "TouchEnd";
    static const std::string TOUCH_MOVE = "TouchMove";
    static const std::string TOUCH_OUT = "TouchOut";
    static const std::string TOUCH_OVER = "TouchOver";
    static const std::string TOUCH_TAP = "TouchTap";
	static const std::string TOUCH_PINCH = "TouchPinch";

	/// Event for handle input from screen.
    class TouchEvent: public Event
    {   
    public:
        
        TouchEvent(std::string type): 
		  Event(type), 
		  localX(0), 
		  localY(0),
		  stageX(0),
		  stageY(0),
		  movementX(0),
		  movementY(0),
		  pinch(0),
          touchId(0)
		{};
        
        float localX;
        float localY;
        float stageX;
        float stageY;
		float movementX;
		float movementY;
		float pinch;
        char  touchId;
        
        virtual std::string toString()
        {
            std::ostringstream oss;
            oss << "(type= " << type.c_str() << ", lx=" << localX << ", ly=" << localY << ", sx=" << stageX << ", sy=" << stageY << ")";
            return oss.str();
        }
    };
    
}

#endif
