#ifndef Rag_iosUtils_h
#define Rag_iosUtils_h

#include <string>
#include "KeyboardType.h"

namespace rag
{
    class iosUtils
    {
    public:
        
        // Returns main bundle url (read only)
        static std::string getResourcePath(const std::string& path);
        
        // Returns url when you have read/write permission.
        static std::string getSaveFolder(const std::string& path);
        
        static void showKeyboard();
        static void hideKeyboard();
        static bool requestingKeyboard(); // Tells if the application wants to show the kayboard.
        static void setKeyboardType(KeyboardType type);
        static int  getKeyboardType();
        
        static void setView(void* view);
        static void* getView();
        
        static void setViewController(void* _view);
        
        // Returns a string with the application version number
        static std::string getAppVersion();
        
        // Returns the preferred device language
        static std::string getLanguage();
        
        static std::string toUpperUTF8(std::string s);
        static std::string toLowerUTF8(std::string s);
        
        static void postTweet(const std::string& defaultText);
        
        static std::string getNewUID();
        
        static std::string getIslandID();
        static std::string getUserID();
        static std::string getUserName();
        
        // Local notifications helper
        static void scheduleNotification(std::string _sku, std::string _body, int timeLeft, bool forceDayHours = false);
        static void cancelNotification(std::string skustr);
        
        static void openExternalURL(std::string urlString);
        
        static void activatePushNotifications();
        
        static void iosLog(const char* format, ...);
        static void iosLogError(const char* format, ...);
        static void iosLogEnable(bool value);
        
        static void sendErrorMail(std::string buildVersionS, std::string playerIDS);
        
        static std::string getIDFA();
        
    private:
        
        static bool logEnabled;
        static std::string deviceModel;
        
    };
    
}

#endif
