//
//  Emitter.h
//  ragnar
//
//  Created by Ivan Sanchez Luque on 1/9/13.
//
//

#ifndef __ragnar__Emitter__
#define __ragnar__Emitter__

#include <rag/DisplayObject.h>
#include "particles/Descriptor.h"
#include "particles/Particle.h"
#include <rag/Image.h>
#include <list>

namespace particles
{
	class ParticlePusher;

    class Emitter: public rag::DisplayObject
    {
        
    public:
        
        Emitter(Descriptor descriptor);
        virtual ~Emitter();

		static void fireAndForget(rag::DisplayObject* parent, glm::vec2 position, std::string path);

		void setDescriptor(Descriptor descriptor);
        
        void fire();
        void stop();

		int getParticleCount() { return particle_count; }

		void addParticle(); // You don't usually need to call this, but it's here for more control.

		bool wrapScreen;
        
    private:
        
        virtual void logicUpdate();
        virtual void render();

		void fitToScreen(glm::vec4& v0, glm::vec4& v1, glm::vec4& v2, glm::vec4& v3);
        
        Descriptor descriptor;
        
        float random() { return ((float) rand() / (RAND_MAX)); }
        float random(float min, float max) { return (min + ((max - min) * random())); }
        
        bool started;
        
        bool stopRequested;
        
        rag::Image* image;
        
        int particle_count;

		int particleWidth;
		int particleHeight;

		std::list<Particle*> particles;

		friend class TimedParticlePusher;
		friend class ExplosiveParticlePusher;
		friend class ContinuousParticlePusher;
		friend class LowPacedParticlePusher;

		ParticlePusher* pusher;
    };
}

#endif /* defined(__ragnar__Emitter__) */
