//
//  Particle.h
//  ragnar
//
//  Created by Ivan Sanchez Luque on 1/9/13.
//
//

#ifndef ragnar_Particle_h
#define ragnar_Particle_h

#include <rag/DisplayObject.h>

namespace particles
{
    class Particle
    {
        
    public:
        
       Particle();
        
        
        // Movement parameters
        // ------------------------------------------------------------------------
        glm::vec2 gravity;
        glm::vec2 velocity;
        float initialVelocity;
        
        float radialAcceleration;
        glm::vec2 radialVelocity;
        
        
        // Particle appareance
        // ------------------------------------------------------------------------
        float scaleStart;
        float scaleEnd;
        
        rag::Color colorStart;
        rag::Color colorEnd;
        
        float spinStart;
        float spinEnd;
        
        float currentLife;
        float lifeTime;

		bool  orientated;
        
        virtual void logicUpdate();

		float x, y, scaleX, scaleY, angle;
        rag::Color color;

    private:
        
    };


	class AnimatedParticle: public Particle
	{

	public:

		AnimatedParticle(int fps, int numFrames, bool firstFrameRandom);

		virtual void logicUpdate();

		int fps;
		int currentFrame;
		int numFrames;
		float frameTime;
		float frameDuration;
	};
}

#endif
