#include "AlphaTo.h"

using namespace behaviours;

AlphaTo::AlphaTo(float target, float time):
acquired(false),
origin(0)
{
    name = "AlphaTo";
    this->target = target;
    this->time = time;
}

void AlphaTo::logicUpdate()
{
    if (!parent) return;
    
    if (!acquired)
    {
        origin = parent->color.a;
        acquired = true;
        timer.start(time);
    }
    
    float delta = timer.getDelta();
    parent->color.a = origin * (1-delta) + target * delta;
    
    if (timer.finished())
    {
        events::Event e(events::ALPHA_TO_COMPLETE);
        dispatchEvent(e);
        
        parent->deleteChild(this);
    }
}


////////////////////////////////////////////////////////////////////////////////

AlphaFromTo::AlphaFromTo(float origin, float target, float time)
{
    name = "AlphaFromTo";
    this->origin = origin;
    this->target = target;
    this->time = time;
}

void AlphaFromTo::logicUpdate()
{
    if (!parent) return;
    if (!timer.running())
        timer.start(time);
    
    float delta = timer.getDelta();
    parent->color.a = origin * (1-delta) + target * delta;
    
    if (timer.finished())
    {
        parent->color.a = target;
        
        events::Event e(events::ALPHA_TO_COMPLETE);
        dispatchEvent(e);
        
        parent->deleteChild(this);
    }
}