#ifndef Rag_ButtonBehaviour_h
#define Rag_ButtonBehaviour_h

#include <rag/TouchEvent.h>
#include <rag/DisplayObject.h>

namespace rag
{
    
    class ButtonBehaviour: public DisplayObject, events::EventListener
    {
        
    public:
        
		ButtonBehaviour(std::string soundName = "", bool buttonForList = false, bool isAlphaChanging = true);
        
        virtual void logicUpdate();
        
        virtual void onEvent(const std::string& type, events::Event& event);
        
        void setEnabled(bool value, bool changeAlpha = true);
		bool isEnabled() { return enabled; }

		void setHighlighted(bool value);

    private:
        
		void removeListeners();
		void addListeners();
		void	onStateChanged();

        bool    added;
        bool    mouseDown;
        glm::vec2   mouseDownPoint;
        std::string soundName;
        
        bool    buttonForList;
		bool	isAlphaChanging;
        Timer   timer;
        
        bool    enabled;
        bool	highlighted;
		std::string prevFragment;
    };
}

#endif
