#ifndef _DWARFS_CHANGE_VALUE_H_
#define _DWARFS_CHANGE_VALUE_H_

#include <rag/DisplayObject.h>

namespace behaviours
{

class ChangeValueTo: public rag::DisplayObject
{
    
public:
    
	ChangeValueTo(float& value, float to, float time):
    elapsed(.0f),
    to(to),
    time(time),
    value(value)
	{
		from = value;
	}
    
private:
    
	virtual void logicUpdate()
	{
		if (!timer.running())
		{
			timer.start(time);
		}
		float delta = timer.getDelta(rag::Ease::acelBreak_01);
		
		value = (1.0f-delta) * from + delta * to;
        
		if (timer.finished())
		{
			parent->deleteChild(this);
		}
	}
    
	rag::Timer timer;
	float from;
	float& value;
	float to;
	float time;
	float elapsed;
    
};

} // behaviours

#endif