#include "Delay.h"

using namespace behaviours;

Delay::Delay(DisplayObject* object, float delay):
objectAdded(false),
forceFinish(false)
{
    name = "Delay";
    this->object = object;
    timer.start(delay);
}

Delay::~Delay()
{
    if (!objectAdded)
        delete(object); // the object was never inserted in the display list.
}

void Delay::speedUp()
{
	forceFinish = true;
}

void Delay::logicUpdate()
{
    if (timer.finished() || forceFinish)
    {
        parent->addChild(object);
        objectAdded = true;
        parent->deleteChild(this);
    }
}
