#include "MoveTo.h"

using namespace behaviours;
using namespace rag;





MoveTo::MoveTo(glm::vec2 point, float time, Ease::EaseType ease):
acquired(false)
{
    this->ease = ease;
    b = point;
    timer.start(time);
}

void MoveTo::logicUpdate()
{
    if (!parent) return;
    
    if (!acquired)
    {
        a = glm::vec2(parent->getX(), parent->getY());
        acquired = true;
    }
    
	glm::vec2 p = glm::mix(b, a, timer.getDelta(ease));
    
    parent->setX(p.x);
    parent->setY(p.y);
    
    if (timer.finished())
    {
        events::Event e(events::MOVE_COMPLETED);
        dispatchEvent(e);
        parent->deleteChild(this);
    }
}





MoveFromTo::MoveFromTo(glm::vec2 a, glm::vec2 b, float time, Ease::EaseType ease, bool loop):
started(false)
{
	this->name = "MoveFromTo";
    this->a = a;
    this->b = b;
    this->time = time;
    this->ease = ease;
    this->loop = loop;
}

void MoveFromTo::logicUpdate()
{
    if (!parent) return;
    
    if (!started)
    {
        started = true;
        timer.start(time);
    }
    
    glm::vec2 p = glm::mix(b, a, timer.getDelta(ease));
    
    parent->setX(p.x);
    parent->setY(p.y);
    
    if (timer.finished())
    {
        if (loop) {
            timer.start(time);
        }
        else {
            events::Event e(events::MOVE_COMPLETED);
            dispatchEvent(e);
            parent->deleteChild(this);
        }
    }
}