#ifndef Rag_MoveTo_h
#define Rag_MoveTo_h

#include <rag/DisplayObject.h>
#include <rag/Timer.h>

namespace events
{
    static const std::string MOVE_COMPLETED = "MoveCompleted";
}

namespace behaviours
{
    class MoveTo: public rag::DisplayObject
    {
        
    public:
        
        MoveTo(glm::vec2 point, float time, rag::Ease::EaseType ease = rag::Ease::acelBreak_01);
        
    private:
        
        virtual void logicUpdate();
        
        rag::Timer timer;
        glm::vec2 a;
        glm::vec2 b;
        bool acquired;
        rag::Ease::EaseType ease;
    };
    
    
    class MoveFromTo: public rag::DisplayObject
    {
        
    public:
        
        MoveFromTo(glm::vec2 a, glm::vec2 b, float time, rag::Ease::EaseType ease = rag::Ease::acelBreak_01, bool loop = false);
        
    private:
        
        virtual void logicUpdate();
        
        rag::Timer timer;
        float       time;
        glm::vec2 a;
        glm::vec2 b;
        bool        started;
		bool        loop;
        rag::Ease::EaseType ease;
    };
}

#endif
