#include "Rotate.h"

using namespace behaviours;

Rotate::Rotate(float frequency, int intervals):
angle(0)
{
    this->frequency = frequency;
    this->intervals = intervals;
    
    timer.start(frequency);
}

// regular intervals
void Rotate::logicUpdate()
{
    if (timer.finished())
    {
        angle += (360.0f / intervals);
        
        while (angle > 360) 
            angle -= 360;
        
        parent->setAngle(angle);
        timer.start(frequency);
    }    
}




RotateContinuous::RotateContinuous(float frequency, bool CCW):
angle(.0f)
{
    this->frequency = frequency;
	this->CCW = CCW;
}

void RotateContinuous::logicUpdate()
{
	if (CCW)
	{
		angle += (rag::Timer::deltaTime * 360) / frequency;
		if (angle > 360.0f)
			angle -= 360.0f;
	}
	else
	{
		angle -= (rag::Timer::deltaTime * 360) / frequency;
		if (angle < 0.0f)
			angle += 360.0f;
	}
	
    parent->setAngle(angle);
}



RotateFromTo::RotateFromTo(float origin, float target, float time)
{
    this->origin = origin;
    this->target = target;
    this->time = time;
}

void RotateFromTo::logicUpdate()
{
    if (!timer.running())
    {
        timer.start(time);
    }
    
    float delta = timer.getDelta();
    
    parent->setAngle(origin * (1 - delta) + target * delta);
}