#ifndef rag_Rotate_h
#define rag_Rotate_h

#include <rag/DisplayObject.h>

namespace behaviours
{
    class Rotate: public rag::DisplayObject
    {
        
    public:
        
        Rotate(float frequency = 0.05, int intervals = 12);
        
    private:
        
        virtual void        logicUpdate();
        
        rag::Timer          timer;
        
        float               angle;
        float               frequency;
        int                 intervals;
        
    };
    
    
    
    
    class RotateContinuous: public rag::DisplayObject
    {
    public:
        RotateContinuous(float frequency, bool CCW = false);
        
    private:
        
        virtual void        logicUpdate();
        
        float               angle;
        float               frequency;

		bool CCW;
    };
    
    
    
    
    class RotateFromTo: public rag::DisplayObject
    {
        
    public:
        
        RotateFromTo(float origin, float target, float time);
        
    private:
        
        virtual void        logicUpdate();
        
        float               origin;
        float               target;
        float               time;
        rag::Timer          timer;
    };
}

#endif
