#ifndef AppleCoder_OpenGLES_00_ScaleTo_h
#define AppleCoder_OpenGLES_00_ScaleTo_h

#include <rag/Timer.h>
#include <rag/DisplayObject.h>

namespace events
{
    static const std::string SCALE_COMPLETE = "ScaleComplete";
}

static const std::string SCALE_ID = "ScaleID";

namespace behaviours
{
    class ScaleTo: public rag::DisplayObject
    {
    public:
        
        ScaleTo(float target, float time, rag::Ease::EaseType ease = rag::Ease::linear_01);
        
        virtual void logicUpdate();
        
    private:
        
        float target;
        float origin;
        bool acquired;
		float time;
        rag::Timer timer;
		rag::Ease::EaseType ease;
    };
    
    
    class ScaleFromTo: public rag::DisplayObject
    {
    public:
        
        ScaleFromTo(float origin, float target, float time, rag::Ease::EaseType ease = rag::Ease::linear_01);
        
        virtual void logicUpdate();
        
    private:
        
        float target;
        float origin;
        bool acquired;
        rag::Timer timer;
        float time;
        rag::Ease::EaseType ease;
    };


	class ScaleFromToX: public rag::DisplayObject
    {
    public:
        
        ScaleFromToX(float origin, float target, float time, rag::Ease::EaseType ease = rag::Ease::linear_01);
        
        virtual void logicUpdate();
        
    private:
        
        float target;
        float origin;
        bool acquired;
        rag::Timer timer;
        float time;
        rag::Ease::EaseType ease;
    };

	class ScaleFromToY : public rag::DisplayObject
	{
	public:

		ScaleFromToY(float origin, float target, float time, rag::Ease::EaseType ease = rag::Ease::linear_01);

		virtual void logicUpdate();

	private:

		float target;
		float origin;
		bool acquired;
		rag::Timer timer;
		float time;
		rag::Ease::EaseType ease;
	};
}

#endif
