#include "Content.h"
#include <rag/File.h>

using namespace rag;

class DefaultContentLoader: public ContentLoaderInterface
{
	virtual std::string load(std::string file)
	{
		return File::load(file);
	}
};

namespace detail 
{
	DefaultContentLoader defaultContentLoader;
}


Content::Content()
{
	loader = &detail::defaultContentLoader;
}

std::string Content::load(const std::string file)
{
	return loader->load(file);
}

void Content::setContentLoader(ContentLoaderInterface* loader)
{
	this->loader = loader;
}