#ifndef rag_FileUtils_h
#define rag_FileUtils_h

#include <rag/File.h>
#include <string>
#include <vector>

namespace rag
{
	class ArchiveUtils
	{
	public:
		static std::string loadGZ(const std::string& filepath, const char* mode = "rb", bool showErrors = true);
		static std::string loadTGZ(const std::string& archivePath, const std::string& filepath, const char* mode = "rb", bool showErrors = true);
		static bool unpackTGZ(const std::string& archivePath, const char* mode = "rb", bool showErrors = true);
		static bool unpackAssetsTGZ(const std::string& archivePath, const char* mode = "rb", bool showErrors = true);

	private:
		static bool unpackTGZFolder(const std::string& archivePath, const std::string& folder, const char* mode, bool showErrors);
		static std::vector<std::string> unpackedFiles;
	};

	//utility class to read binary files
	class BinaryFile : public File
	{
	public:
		BinaryFile(const std::string& path, bool bundle = true);

		//bool open(std::string mode = "rb", bool showErrors = true);
		//void close();
		//size_t read(void* _buffer, size_t _count);

		void writeInt(int value);
		void writeFloat(float value);
		void writeString(const std::string& value);

		int readInt();
		float readFloat();
		std::string readString();

	private:
		//unsigned char* buffer;
		//int bufsize;
		//int bufindex;
	};
}

#endif
