#include "TextView.h"
#include "core/File.h"

using namespace rag;

TextView::TextView() :
isOpen(false)
{
}

TextView::~TextView()
{
    close();
}

void TextView::clear()
{
	content.clear();
}

void TextView::add(const std::string& value)
{
	content.append(value);
}

void TextView::loadFromFile(const std::string& filename)
{
	content = File::load(filename, false, "rb", false);
}

void TextView::open()
{
	if (isOpen) return;
	isOpen = true;

	rag::Rectangle bounds = getBounds();
#ifdef __APPLE__
	CGRect rect = CGRectMake(bounds.x, bounds.y, bounds.width, bounds.height);
	UITextView* textView = [[UITextView alloc] initWithFrame:rect];
	NSString* text = [NSString stringWithUTF8String:content.c_str()];
	textView.text = text;
	
	UIView* view = (UIView*)iosUtils::getView();
	[view addSubview:textView];
	[textView scrollRangeToVisible:NSMakeRange(text.length, 0)];
	[textView becomeFirstResponder];
	[textView release];
	
	handle = (void*)textView;
#endif
}

void TextView::close()
{
	if (!isOpen) return;
	isOpen = false;

#ifdef __APPLE__
	UITextView* textView = (UITextView*)handle;
    [textView removeFromSuperview];
	parent->deleteChild(this);
#endif
}
