#ifndef rag_TimeUtils_h
#define rag_TimeUtils_h

#include <string>

namespace rag 
{
    class TimeUtils
    {
        
    public:
        
        // abbreviated (1H, 2D, 30m, ...)
        static  std::string format(float seconds, int numFields = 1);    
        static  std::string formatHMS(float seconds); // HH:MM:SS
        static  std::string formatMS(float seconds);  // MM:SS
		static  std::string formatTime(float seconds, bool withSeconds = true);  // MM m SS s

        /**
        * Returns elapsed time abbreviated
        * examples: "1 month ago", "2 days ago", "3 hours ago", "4 minutes ago", "5 seconds ago"
        */
        static std::string getElapsedTime(time_t from);

		// date in yyyy-mm-dd format
		// Deprecated - use now() instead
		static std::string getDateString(); //now
		// Deprecated - use now() instead
		static std::string getDateString(time_t date);
		
		static std::string getTimeString(time_t time);

		static std::string now(std::string format = "%Y-%m-%d %X");
    };
}

#endif
