#include "XML.h"

namespace xml
{
	int getAsInt(xmlNode* node, const char* property, int defaultValue)
	{
		char* str = (char*)xmlGetProp(node, (const xmlChar*)property);
		int ret = str ? atoi(str) : defaultValue;
		xmlFree(str);
		return ret;
	}

	float getAsFloat(xmlNode* node, const char* property, float defaultValue)
	{
		char* str = (char*)xmlGetProp(node, (const xmlChar*)property);
		float ret = str ? (float)(atof(str)) : defaultValue;
		xmlFree(str);
		return ret;
	}

	std::string getAsString(xmlNode *node, const char *property, std::string defaultValue)
	{
		char* str = (char*)xmlGetProp(node, (const xmlChar*)property);
		std::string ret = str ? str : defaultValue;
		xmlFree(str);
		return ret;
	}

	bool existsProperty(xmlNode *node, const char *property)
	{
		char* str = (char*)xmlGetProp(node, (const xmlChar*)property);
		bool exists = str != NULL;
		xmlFree(str);
		return exists;
	}
}



