uniform mat4 Projection;
uniform mat4 View;
uniform mat3 normal_matrix; // normal matrix
uniform vec3 ec_light_dir; // light direction in eye coords
attribute vec3 Position;
attribute vec3 Normal;
attribute vec2 TexCoordinate; // Per-vertex texture coordinate information we will pass in.
varying float v_diffuse;
varying vec2 v_TexCoordinate;   // This will be passed into the fragment shader.

void main(void) {    
	// put vertex normal into eye coords
 	vec3 ec_normal = normalize(normal_matrix * Normal);
 	// emit diffuse scale factor, texcoord, and position
 	v_diffuse = max(dot(ec_light_dir, ec_normal), 0.0);
    v_TexCoordinate = TexCoordinate;
    gl_Position = Projection * View * vec4(Position, 1.0);
}