uniform mat4 Projection;
uniform mat4 MVP;
uniform mat4 boneMatrix[50];
attribute vec3 Position;
attribute vec2 TexCoordinate; // Per-vertex texture coordinate information we will pass in.
attribute vec4 weight;
attribute vec4 matrixIndex;

varying vec2 v_TexCoordinate;   // This will be passed into the fragment shader.



void main(void) {
    v_TexCoordinate = TexCoordinate;
 
    mat4 matTransform = boneMatrix[int(matrixIndex.x)] * weight.x;
    matTransform += boneMatrix[int(matrixIndex.y)] * weight.y;
    matTransform += boneMatrix[int(matrixIndex.z)] * weight.z;
    float finalWeight = 1.0 - ( weight.x + weight.y + weight.z );
    matTransform += boneMatrix[int(matrixIndex.w)] * finalWeight;
    
    gl_Position = (MVP) * (matTransform * vec4(Position, 1.0));
}