#include "App.h"
#include <rag/rag.h>
#include "test/Test.h"

using namespace rag;

class Game : public rag::DisplayObject
{
public:
	Game()
	{
		rag::Test* test = new rag::Test();
		addChild(test);
	}
};

App::App(const char* cmdArgs)
{
	LOGI("Screen (%dx%d)", Screen::width, Screen::height);
	LOGI("Real Screen (%dx%d)", Screen::realWidth, Screen::realHeight);
	LOGI("Screen Apple Scale: %f", Screen::scale);
	LOGI("scaleBest: %f", Screen::scaleBest);
	LOGI("factor: %.2fx%.2f", Screen::factorX, Screen::factorY);

	renderer.init();

	stage.name = "stage";

	// best fit to screen, since everything in game expects iPad resolution.    
	stage.setScaleX(Screen::scaleBest);
	stage.setScaleY(Screen::scaleBest);

	stage.addChild(new Game());
}

App::~App()
{
}

NativeApp* GetNativeApp(const char* cmdArgs)
{
	static NativeApp* app = NULL;

	if (!app)
		app = new App(cmdArgs);

	return app;
}
