from xml.dom import minidom
import os.path
import subprocess
import shutil

def binarize_flash_folder(full_path):
    print "binarizing folder " + full_path
    
    for dirpath, dirnames, filenames in os.walk(full_path):
        for filename in [f for f in filenames if f.endswith(".xml")]:
            file = os.path.join(dirpath, filename)
            print file
            
            program = './tools/xfl_bin.exe'
            subprocess.call([program, full_path, os.path.relpath(file, full_path)])
            os.remove(file)
    return
    

# walk all sub folders
for dirname, dirnames, filenames in os.walk("."):
    for d in dirnames:
        fulldir = os.path.join(dirname, d)
        library = os.path.join(fulldir, 'LIBRARY')
                
        if os.path.isdir(library):
            
            binarize_flash_folder(library)
            
            DOMDocument = os.path.join(fulldir, 'DOMDocument.xml')
            if os.path.isfile(DOMDocument):
                os.remove(DOMDocument)
            
            MobileSettings = os.path.join(fulldir, 'MobileSettings.xml')
            if os.path.isfile(MobileSettings):
                os.remove(MobileSettings)
                
            PublishSettings = os.path.join(fulldir, 'PublishSettings.xml')
            if os.path.isfile(PublishSettings):
                os.remove(PublishSettings)
            
            meta = os.path.join(fulldir, 'META-INF')
            if os.path.isdir(meta):
                shutil.rmtree(meta)
            