from xml.dom import minidom
import os.path
import sets
import sys

from colorama import init
init()
from colorama import Fore, Back, Style

print "\nClean flash utility\n"

def check_flash_folder(full_path, delete):

	print Fore.WHITE + "running on folder " + full_path

	used = set()

	# Parse elements in actual flash library

	xmldoc = minidom.parse(full_path + '/DOMDocument.xml')
	itemlist = xmldoc.getElementsByTagName('Include') 
	xmls = set()
	for s in itemlist :
		used.add(s.attributes['href'].value)
		xmls.add(s.attributes['href'].value)
		
	itemlist = xmldoc.getElementsByTagName('DOMBitmapItem') 
	for s in itemlist :
		used.add(s.attributes['href'].value)


	paths = set()
	warnings = set()
	
	library = full_path + '/LIBRARY'

	# Check file system to find all existing files
	for dirname, dirnames, filenames in os.walk(library):
		for filename in filenames:
			path = os.path.join(dirname, filename).replace('\\', '/')[len(library)+1:]
			paths.add(path)
			if path not in used:
				name, extension = os.path.splitext(filename)
				if extension not in (".bin"):
					warnings.add(path)
				
				# REMOVE unused files.
				if delete:
					name, extension = os.path.splitext(filename)
					if extension not in (".bin"): # Remove .bin is a bad idea.
						print Fore.RED + dirname + '/' + filename
						os.remove(dirname + '/' + filename)
				
	if len(warnings) > 0:
		print Fore.YELLOW
		print "\nWarnings (files that are wasting space): " + str(len(warnings))
		for i in warnings :
			print i
			

	criticals = set()

	for i in used :
		if ( (i not in paths) and (i + ".bin" not in paths) ):
			criticals.add(i)
			
	if len(criticals) > 0:
		print Fore.RED
		print "\nCritical errors (will make the app crash): " + str(len(criticals))
		for i in criticals :
			print i
	
	print Fore.WHITE

		
def usage():
	print "\nusage:\n"
	print "clean_flash [-d]"
	print "-d delete unused files"
	#print "-b binarize files"
		
# walk all sub folders
def main(argv):

	delete = 0
	
	for opt in sys.argv:
		if opt == sys.argv[0]:
			continue
		if opt == '-h':
			usage()
			sys.exit()
		elif opt == '-d':
			delete = 1
		else:
			print opt + " is an invalid param"
			usage()
			sys.exit(2)
	
	for dirname, dirnames, filenames in os.walk("."):
		for d in dirnames:
			fulldir = os.path.join(dirname, d)
			if os.path.isfile(fulldir + '/DOMDocument.xml'):
				check_flash_folder(fulldir, delete)
    

if __name__ == "__main__":
   main(sys.argv[1:])
