-- premake5.lua
workspace "SimpleRagProject"
   configurations { "Debug", "Release" }
   location "../build"

project "SimpleRagProject"
   kind "WindowedApp"
   language "C++"
   --targetdir "../bin/%{cfg.buildcfg}"
   location "../build"
   debugdir "../"
   
   --configuration "Debug"
    --debugdir "../"

   files { 
   "../src/**.cpp", 
   "../src/**.c",
   "../src/**.h",
   "../../rag/**.cpp", 
   "../../rag/**.c",
   "../../rag/**.h",
   }
   
   removefiles 
   { 
   --"**/texture-atlas/**",
   --"**/win/**",
   "../../**/android/**",
   "../../**/texture-atlas/**",
   "../../rag/external/glm/test/**",
   "../../rag/tools/**",
   --"**/ios/**",
   --"../../rag/win/*", -- removes all under rag/win
   --"../../rag/win/**", -- removes all under rag/win recursively
   "../../**/PowerVR/**", -- removes all under rag/win recursively
   }
   
   includedirs { 
   "../../rag",
   "../../rag/include",
   "../../rag/external",
   "../../rag/external/glm",
   "../../rag/external/libxml2/include",
   "../../rag/external/spine/include",
   "../../rag/external/pvr",
   "../../rag/external/pvr/OGLES2",
   "../../rag/external/zlib",
   "../../rag/external/libjpeg",
   "../../rag/external/libpng",
   "../../rag/external/jansson",
   "../../rag/external/audio/include",
   
   -- win only!
   "../../rag/win/AntTweakBar/include",
   "../../rag/win/pthreads/include",
   "../../rag/win/PowerVR/Include"
   }
   
   libdirs { 
    "../../rag/win/AntTweakBar/lib",
    "../../rag/win/pthreads/lib/x86",
    "../../rag/win/PowerVR/Windows/x86_32/Lib",
    "../../rag/external/spine/debug",
   }
   
   links {
    "AntTweakBar",
    "libGLESv2",
    "libEGL",
    "pthreadVC2",
    "ws2_32",
    "winmm",
    "psapi",
    "propsys",
    "shlwapi",
    "comctl32",
    "spine-c"
   }

   filter "configurations:Debug"
      defines { 
      "DEBUG", 
      "WIN32", 
      "NO_vsnprintf" -- zlib
      }
      flags { 
      "Symbols", 
      "WinMain" 
      }

   filter "configurations:Release"
      defines { 
      "NDEBUG", 
      "WIN32",
      "NO_vsnprintf" -- zlib
      }
      flags { 
        "WinMain" 
      }
      optimize "On"
      
      
    -- TODO Add postbuild event to copy dlls and .exe to project root.
    