#ifndef _RAG_FILE_UTIL_H_
#define _RAG_FILE_UTIL_H_

#include <rag/Event.h>
#include <rag/EventDispatcher.h>

namespace events
{
	class FileUtilEvent: public Event
	{
	public:
		FileUtilEvent(const std::string& type):
			Event(type),
            fromBundle(false)
		{};

		std::string file;
        bool fromBundle;
	};

	static const std::string FILE_SELECTED = "FileSelected";
};
class FileUtil: public events::EventDispatcher
{
public:

	static FileUtil& getInstance()
	{
		static FileUtil instance;
		return instance;
	}

	void startOpenFileDialog();
	void startSaveFileDialog();

private:

	FileUtil(){};

	void showDialog(bool load);

};

#endif