#include "winUtils.h"
#include <rag/Platform.h>
#include <stdio.h>
#include <stdarg.h>
#include <ctype.h>
#include <sstream>
#include "shared/utils/TimeUtils.h"

bool WinUtils::win_log_enabled = true;

WinUtils& WinUtils::getInstance()
{
    static WinUtils instance;
    return instance;
}

void WinUtils::setWindow(HWND _hWnd)
{
	hWnd = _hWnd;
}

HWND WinUtils::getWindow()
{
	return hWnd;
}

void WinUtils::logEnabled(bool enabled)
{
	win_log_enabled = enabled;
}

void WinUtils::win32_printf(const char *format, ...)
{
	if (!win_log_enabled) return;

	char buffer[64*1024];
	va_list args;
	va_start(args, format);
	vsnprintf(buffer, 64 * 1024, format, args);
	va_end(args);

	std::stringstream ss;
	ss << rag::TimeUtils::now() << ' ' << buffer << std::endl;

    OutputDebugString(ss.str().c_str());
}

void WinUtils::win32_printfe(const char *format, ...)
{
	if (!win_log_enabled) return;

	char buffer[64 * 1024];
	va_list args;
	va_start(args, format);
	vsnprintf(buffer, 64 * 1024, format, args);
	va_end(args);

	std::stringstream ss;
	ss << rag::TimeUtils::now() << ' ' << buffer << std::endl;

    OutputDebugString(ss.str().c_str());

	MessageBoxA(WinUtils::getInstance().getWindow(), buffer, "Message", MB_OK | MB_ICONINFORMATION);
	Sleep(1);
}

bool WinUtils::handleEvent(HWND hwnd, unsigned int msg, unsigned int wParam, unsigned int lParam)
{
	events::WinEvent ev;
	ev.hwnd = hwnd;
	ev.msg = msg;
	ev.wParam = wParam;
	ev.lParam = lParam;
	dispatchEvent(ev);

	return ev.captured;
}
