#ifndef _WIN_UTILS_H_
#define _WIN_UTILS_H_

#include <rag/EventDispatcher.h>
#include <windows.h>

#define winutils WinUtils::getInstance()

#define atoll(S) _atoi64(S)

namespace events 
{
	static const std::string WIN_EVENT = "WinEvent";

	class WinEvent: public events::Event
	{
	public:
		WinEvent() : Event(events::WIN_EVENT) {}

		HWND hwnd;
		unsigned int msg;
		unsigned int wParam;
		unsigned int lParam;
	};
}

class WinUtils: public events::EventDispatcher
{
public:
	static WinUtils& getInstance();

	static void win32_printf(const char *format, ...);
	static void win32_printfe(const char *format, ...);

	static void logEnabled(bool enabled);

	void setWindow(HWND _hWnd);
	HWND getWindow();

	bool handleEvent(HWND hwnd, unsigned int msg, unsigned int wParam, unsigned int lParam);

private:

	static bool win_log_enabled;
	HWND hWnd;
};

#endif